class ITERATOR_ON_OBJECT
inherit
	ITERATOR[OBJECT]
	KNOWS_MASTER
creation make
feature
	name : STRING

	make is
	do
	end

	set_name(n : STRING) is
	do
		name := n
		if name.is_equal("all") then
			global := true
		else
			global := false
		end
	end

	start is
	do
		list := dungeon_master.zzt.board.object_list
		i := list.lower - 1
		next
	end

	next is
	do
		i := i + 1
		from found := false
		until found or else i > list.upper
		loop
			if global or else list.item(i).id_lower.is_equal(name) then
				found := true
			else
				i := i + 1
			end
		end
	end

	item : OBJECT is
	do
		Result := list.item(i)
	end

	is_off : BOOLEAN is
	do
		Result := not found
	end

feature {NONE}
	list : LINKED_LIST[OBJECT]

	global : BOOLEAN

	found : BOOLEAN
	i : INTEGER
end
