class KEY
inherit
	DIRECTION
	MONSTER_FLOOR
		redefine
			make,
			put_colour,
			can_push_me,
			can_convey_me,
			player_touch
		end
creation make, make_for_world
feature
	make(sq : SQUARE) is
	do
		Precursor(sq)
		put_chr(12)
	end

	put_colour(colour_init : INTEGER) is
	do
		Precursor(colour_init)
		key_number := colour - 8
	end

	key_number : INTEGER

	player_touch(p : PLAYER) is
	do
		if p.keys.item(key_number) then
			--already has this key?
		else
			p.keys.put(true, key_number)
			die
			p.move_to(square)
		end
	end

	can_push_me(d : INTEGER) : BOOLEAN is
	once
		Result := true
	end

	can_convey_me : BOOLEAN is true

	kind : STRING is "key"
	zzt_code : INTEGER is 8
end
