class PUSHER
inherit
	DIRECTION
	TICKABLE
creation make, make_for_world
feature
	aim : INTEGER

	read_init_rest(header : OBJECT_HEADER) is
	do
		aim := direction_from_xy(header.xstep, header.ystep)
		put_chr(pusher_chr.item(aim))
	end

	pusher_chr : ARRAY[INTEGER] is
	once
		!!Result.make(min_dir, max_dir)
		Result.put(31, south)
		Result.put(30, north)
		Result.put(16, east)
		Result.put(17, west)
	end

	cycle_tick is
	do
		start_push(aim)
	end

	kind : STRING is "pusher"
	zzt_code : INTEGER is 40
end
