class BEAR
inherit
	ZZT_MONSTER
		redefine
			make
		end
	KNOWS_MASTER
	DIRECTION
creation make, make_for_world
feature
	make(sq : SQUARE) is
	do
		Precursor(sq)
		put_chr(153)
	end

	sensitivity : INTEGER

	read_init_rest(header : OBJECT_HEADER) is
	do
		sensitivity := header.p1
	end

	cycle_tick is
	local
		dx, dy : INTEGER
		d : INTEGER
		sq : SQUARE
	do
		dx := dungeon_master.player.square.location.x
			 - square.location.x
		dy := dungeon_master.player.square.location.y
			 - square.location.y
		
		if dx /= 0 and dy.abs <= (8 - sensitivity) then
			if dx > 0 then
				d := east
			else
				d := west
			end
		elseif dx.abs <= (8 - sensitivity) then
			if dy > 0 then
				d := south
			else
				d := north
			end
		end
		if d > 0 then
			sq := square.adjacent(d)
			--if sq.dominant.kind.is_equal("empty") then
			if can_walk(d) then
				move_to(sq)
			elseif sq.dominant.kind.is_equal("breakable") then
				sq.dominant.blast
				die
			elseif dx + dy = 1 and dx * dy = 0 then
				die
				dungeon_master.player.hurt
			end
		end
	end

	kind : STRING is "bear"
	zzt_code : INTEGER is 34
end
